Attribute VB_Name = "mdlFile"
Option Explicit

Public Const OFN_READONLY = &H1
Public Const OFN_OVERWRITEPROMPT = &H2
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_NOCHANGEDIR = &H8
Public Const OFN_SHOWHELP = &H10
Public Const OFN_ENABLEHOOK = &H20
Public Const OFN_ENABLETEMPLATE = &H40
Public Const OFN_ENABLETEMPLATEHANDLE = &H80
Public Const OFN_NOVALIDATE = &H100
Public Const OFN_ALLOWMULTISELECT = &H200
Public Const OFN_EXTENSIONDIFFERENT = &H400
Public Const OFN_PATHMUSTEXIST = &H800
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_CREATEPROMPT = &H2000
Public Const OFN_SHAREAWARE = &H4000
Public Const OFN_NOREADONLYRETURN = &H8000&
Public Const OFN_NOTESTFILECREATE = &H10000
Public Const OFN_NONETWORKBUTTON = &H20000
Public Const OFN_NOLONGNAMES = &H40000   ' force no long names for 4.x modules
Public Const OFN_EXPLORER = &H80000      ' new look commdlg
Public Const OFN_NODEREFERENCELINKS = &H100000
Public Const OFN_LONGNAMES = &H200000    ' force long names for 3.x modules

Public Const OFN_SHAREFALLTHROUGH = 2
Public Const OFN_SHARENOWARN = 1
Public Const OFN_SHAREWARN = 0
Public Const MAX_PATH = 260

Public Type OpenFileName
  lStructSize As Long
  hwndOwner As Long
  hInstance As Long
  lpstrFilter As String
  lpstrCustomFilter As String
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As String
  nMaxFile As Long
  lpstrFileTitle As String
  nMaxFileTitle As Long
  lpstrInitialDir As String
  lpstrTitle As String
  flags As Long
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As String
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type

Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OpenFileName) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OpenFileName) As Long


Public Function DlgOpenFile(ByVal fHwnd As Long, ByVal fTitle As String, fFilter As String, fFilterIndex As Long, fInitialDir As String, ByVal fFlags As Long) As String

  Dim opfn As OpenFileName

  opfn.lStructSize = Len(opfn)
  opfn.hwndOwner = fHwnd
  opfn.hInstance = App.hInstance
  opfn.lpstrTitle = fTitle
  opfn.lpstrFilter = fFilter
  opfn.nFilterIndex = fFilterIndex
  opfn.lpstrInitialDir = fInitialDir
  opfn.flags = fFlags

  opfn.nMaxFile = MAX_PATH
  opfn.nMaxFileTitle = 64

  opfn.lpstrFile = Space(MAX_PATH - 1)
  opfn.lpstrFileTitle = Space(64)
  If GetOpenFileName(opfn) = 1 Then
   
    DlgOpenFile = Left(opfn.lpstrFile, InStr(1, opfn.lpstrFile, Chr(0)) - 1)
    fInitialDir = Left(opfn.lpstrFile, opfn.nFileOffset)
  End If

End Function

Public Function DlgSaveFile(ByVal fHwnd As Long, ByVal fTitle As String, fFilter As String, fFilterIndex As Long, fInitialDir As String, fDefExt As String, ByVal fFlags As Long) As String

  Dim opfn As OpenFileName

  opfn.lStructSize = Len(opfn)
  opfn.hwndOwner = fHwnd
  opfn.hInstance = App.hInstance
  opfn.lpstrTitle = fTitle
  opfn.lpstrFilter = fFilter
  opfn.nFilterIndex = fFilterIndex
  opfn.lpstrInitialDir = fInitialDir
  opfn.flags = fFlags

  opfn.nMaxFile = MAX_PATH
  opfn.nMaxFileTitle = 64

  opfn.lpstrFile = Space(MAX_PATH - 1)
  opfn.lpstrFileTitle = Space(64)

'    
  opfn.lpstrDefExt = fDefExt

  If GetSaveFileName(opfn) = 1 Then
    
    DlgSaveFile = Left(opfn.lpstrFile, InStr(1, opfn.lpstrFile, Chr(0)) - 1)
    fInitialDir = Left(opfn.lpstrFile, opfn.nFileOffset)
  End If

End Function



