Attribute VB_Name = "modModality"
Option Explicit

' ,     
' tyomitch 2009

Private Declare Function CreateFiber Lib "kernel32" (ByVal dwStackSize As Long, ByVal lpStartAddress As Long, lParam As Any) As Long
Private Declare Sub DeleteFiber Lib "kernel32" (ByVal lpFiber As Long)
Private Declare Function ConvertThreadToFiber Lib "kernel32" (ByVal lParam As Long) As Long
Private Declare Sub SwitchToFiber Lib "kernel32" (ByVal lpFiber As Long)
Private asmGetCurrentFiber(0 To 8) As Byte
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (lpFunc As Any, ByVal Param1 As Long, ByVal Param2 As Long, ByVal Param3 As Long, ByVal Param4 As Long) As Long

Private Declare Function SetTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long) As Long

Private pfMain As Long, pfDialog As Long, Result As String, Done As Boolean
Private nTimer As Long

Private Type DialogParams
    fHwnd As Long
    fTitle As String
    fFilter As String
    fFilterIndex As Long
    fInitialDir As String
    fFlags As Long
End Type

Public Sub ModelessOpenFile(ByVal fHwnd As Long, ByVal fTitle As String, fFilter As String, fFilterIndex As Long, fInitialDir As String, ByVal fFlags As Long)
If pfMain = 0 Then
    pfMain = ConvertThreadToFiber(0)
    asmGetCurrentFiber(0) = &H64
    asmGetCurrentFiber(1) = &HA1
    asmGetCurrentFiber(2) = &H10
    asmGetCurrentFiber(6) = &HC2
    asmGetCurrentFiber(7) = &H10
End If

Dim Params As DialogParams
    Params.fHwnd = fHwnd
    Params.fTitle = fTitle
    Params.fFilter = fFilter
    Params.fFilterIndex = fFilterIndex
    Params.fInitialDir = fInitialDir
    Params.fFlags = fFlags

    Done = False
    
    pfDialog = CreateFiber(0, AddressOf FiberProc, ByVal VarPtr(Params))
    SwitchToFiber pfDialog '    
End Sub

Private Sub FiberProc(Params As DialogParams)
nTimer = SetTimer(0, 0, 10, AddressOf TimerProc)
With Params
    Result = DlgOpenFile(.fHwnd, .fTitle, .fFilter, .fFilterIndex, .fInitialDir, .fFlags)
    Done = True
End With
KillTimer 0, nTimer
SwitchToFiber pfMain
End Sub

Private Sub TimerProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTime As Long)
If Done Then Exit Sub
KillTimer 0, nTimer
If GetCurrentFiber <> pfMain Then SwitchToFiber pfMain
nTimer = SetTimer(0, 0, 10, AddressOf TimerProc)
End Sub

Public Function ModelessGetResult() As String
    If Done Then
        ModelessGetResult = Result
        Done = False
        DeleteFiber pfDialog
        pfDialog = 0
    ElseIf pfDialog Then
        SwitchToFiber pfDialog
    End If
End Function

Public Function GetCurrentFiber() As Long
'    -      winnt.h:
'_inline PVOID GetCurrentFiber( void ) { __asm mov eax, fs:[0x10] }
GetCurrentFiber = CallWindowProc(asmGetCurrentFiber(0), 0, 0, 0, 0)
End Function

